<?php
namespace Controller;

use Zeedhi\Framework\DTO\Response\Message;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Zeedhi\Framework\DTO\Request;

class NutriRecomendation extends \Zeedhi\Framework\Controller\Simple {

    protected $nutriRecomendationService;
    protected $snackMessage;
    protected $util;

    public function __construct(\Service\NutriRecomendation $nutriRecomendationService, \Util\SnackMessage $snackMessage, \Util\Util $util){
        $this->nutriRecomendationService = $nutriRecomendationService;
        $this->snackMessage = $snackMessage;
        $this->util = $util;
    }

    public function getRecomendationByFilial(Request\Filter $request, Response $response){
        try {
            $params = $request->getFilterCriteria()->getConditions();
            
            $CDFILIAL    = $params[0]['value'];

            $recomendation = $this->nutriRecomendationService->getRecomendationByFilial($CDFILIAL);
            $response->addDataSet(new \Zeedhi\Framework\DataSource\DataSet('NutritionalRecomendationRepository', $recomendation));

        } catch (\Exception $e){
            $response->addMessage(new Message($e->getMessage()));
        }   
    }

}  