<?php

namespace Service;
use PHPMailer\PHPMailer\PHPMailer;
use PHPMailer\PHPMailer\Exception as MailerException;

class SMTP {

    const GET_SMTP = "
        SELECT DSSMTPAUTVND, DSEMAILAUVND, NRPORTAAUTVND, CDSENHAAUTVNDWEB,
            DSEMAILCLUSO, LOWER(DSSMTPCRIPT) AS DSSMTPCRIPT, IDTPAUTHSMTP
        FROM PARAMGERAL
    ";

    protected $entityManager;

    public function __construct(\Doctrine\ORM\EntityManager $entityManager) {
        $this->entityManager = $entityManager;
    }

    public function getSMTP(){
        return $this->entityManager->getConnection()->fetchAll(self::GET_SMTP);
    }

    public function sendEmail($name_addressee, $email_addressee, $sender, $subject, $content, $logoEmailInfo = null){
        $SMTP = $this->getSMTP();
        
        $mail = new PHPMailer(true);
            
        $mail->isSMTP();                            // Set mailer to use SMTP
        $mail->Host       = $SMTP[0]['DSSMTPAUTVND'];        // Specify main and backup SMTP servers
        $mail->SMTPAuth   = true;                   // Enable SMTP authentication
        $mail->Username   = $SMTP[0]['DSEMAILAUVND'];    // SMTP username
        $mail->Password   = $SMTP[0]['CDSENHAAUTVNDWEB'];    // SMTP password
        $mail->SMTPSecure = $SMTP[0]['DSSMTPCRIPT'];  // Enable TLS encryption, `ssl` also accepted
        $mail->Port       = $SMTP[0]['NRPORTAAUTVND'];        // TCP port to connect to
        $mail->CharSet    = "UTF-8";
        $mail->Encoding   = "base64";
        $mail->setFrom($SMTP[0]['DSEMAILAUVND'], $sender);
        $mail->addAddress($email_addressee);
        
        // HANDLES THE IMAGE LOGO THAT GETS SENT WITH THE E-MAIL!
        /* ******        IMAGEM PADRÃO        ****** */
        $logoImage = '<img src="https://nocash2.teknisa.com/piaget/images/piaget/logo_empresa.png" style="width: 150px;">';
        /* ***************************************** */
        /*if($logoEmail){
            try {
                if ($logoEmail != "" && file_exists('../../mobile/images/'.$logoEmail)){
                    $logoImage = '<img src="'.$appUrl.'/mobile/images/'.$logoEmail.'" style="width: 150px; padding-top: 20px">';
                }
            } catch (\Exception $e){}   
        }*/
        // -- END OF IMAGE HANDLING
        
        $mail->isHTML(true);                                  // Set email format to HTML
        $mail->Subject = $subject;
        $mail->Body    = self::generateEmail($subject, $content, $logoImage);

        return $mail->send();
    }

    public function sendEmailNotif($name_addressee, $email_addressee, $sender, $subject, $content, $logoEmailInfo = null, $SMTP){
        $username      = $SMTP[0]['DSEMAILAUVND'];
        $server        = $SMTP[0]['DSSMTPAUTVND'];
        $password      = $SMTP[0]['CDSENHAAUTVNDWEB'];
        $port          = $SMTP[0]['NRPORTAAUTVND'];
        $encryption    = $SMTP[0]['DSSMTPCRIPT'];
        $autentication = $SMTP[0]['IDTPAUTHSMTP'];

        $appUrl    = $logoEmailInfo['appUrl'];
        $logoEmail = $logoEmailInfo['logoEmail'];

        // HANDLES THE IMAGE LOGO THAT GETS SENT WITH THE E-MAIL!
        /* ******        IMAGEM PADRÃO        ****** */
        $logoImage = '<img src="https://nocash2.teknisa.com/piaget/images/piaget/logo_empresa.png" style="width: 150px;">';
        /* ***************************************** */
        /*if($logoEmail){
            try {
                if ($logoEmail != "" && file_exists('../../mobile/images/'.$logoEmail)){
                    $logoImage = '<img src="'.$appUrl.'/mobile/images/'.$logoEmail.'" style="width: 150px; padding-top: 20px">';
                }
            } catch (\Exception $e){}   
        }*/
        // -- END OF IMAGE HANDLING

        $message = self::generateEmail($subject, $content, $logoImage);

        $html = new MimePart($message);
        $html->type = "text/html; charset=UTF-8";
        $body = new MimeMessage();

        // E-mail config.
        $body->setParts(array($html));
        $message = new Message();
        $message->setEncoding('UTF-8');
        $message->addTo($email_addressee, $name_addressee)
                ->addFrom($username, $sender)
                ->setSubject($subject)
                ->setBody($body);

        $transport = new SmtpTransport();
        $SMTPOptions = array(
            'name'                  => $server,
            'host'                  => $server,
            'port'                  => $port,
            'connection_class'      => 'login',
            'connection_config'     => array(
                'username'          => $username,
                'password'          => $password,
                'ssl'               => 'tls'
            )
        );
        switch ($autentication){
        case 'N':
            unset($SMTPOptions['connection_config']);
            $SMTPOptions['connection_class'] = 'smtp';
            break;
        case 'S':
        default :
            break;
        }
        $options   = new SmtpOptions($SMTPOptions);
        $transport->setOptions($options);
        $transport->send($message);
    }

    public function generateEmail($subject, $content, $logoImage){
        return
            '<!DOCTYPE html>'.
            '<head>'.
            '<style>
            .TabelaEmail {
                margin:0px;padding:0px;
                width:100%;
                box-shadow: 10px 10px 5px #888888;
                border:1px solid #000000;

                -moz-border-radius-bottomleft:0px;
                -webkit-border-bottom-left-radius:0px;
                border-bottom-left-radius:0px;

                -moz-border-radius-bottomright:0px;
                -webkit-border-bottom-right-radius:0px;
                border-bottom-right-radius:0px;

                -moz-border-radius-topright:0px;
                -webkit-border-top-right-radius:0px;
                border-top-right-radius:0px;

                -moz-border-radius-topleft:0px;
                -webkit-border-top-left-radius:0px;
                border-top-left-radius:0px;
            }.TabelaEmail table{
                border-collapse: collapse;
                    border-spacing: 0;
                width:100%;
                height:100%;
                margin:0px;padding:0px;
            }.TabelaEmail tr:last-child td:last-child {
                -moz-border-radius-bottomright:0px;
                -webkit-border-bottom-right-radius:0px;
                border-bottom-right-radius:0px;
            }
            .TabelaEmail table tr:first-child td:first-child {
                -moz-border-radius-topleft:0px;
                -webkit-border-top-left-radius:0px;
                border-top-left-radius:0px;
            }
            .TabelaEmail table tr:first-child td:last-child {
                -moz-border-radius-topright:0px;
                -webkit-border-top-right-radius:0px;
                border-top-right-radius:0px;
            }.TabelaEmail tr:last-child td:first-child{
                -moz-border-radius-bottomleft:0px;
                -webkit-border-bottom-left-radius:0px;
                border-bottom-left-radius:0px;
            }.TabelaEmail tr:hover td{
                background-color:#ffffff;
            }
            .TabelaEmail td{
                vertical-align:middle;
                    background:-o-linear-gradient(bottom, #f4c395 5%, #fcddbf 100%);    background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #f4c395), color-stop(1, #fcddbf) );
                background:-moz-linear-gradient( center top, #f4c395 5%, #fcddbf 100% );
                filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#f4c395", endColorstr="#fcddbf");    background: -o-linear-gradient(top,#f4c395,fcddbf);

                background-color:#ffffff;

                height: 40px;
                border:1px solid #000000;
                border-width:0px 1px 1px 0px;
                text-align:left;
                padding:7px;
                font-size:10px;
                font-family:Arial;
                font-weight:normal;
                color:#000000;
            }.TabelaEmail tr:last-child td{
                border-width:0px 1px 0px 0px;
            }.TabelaEmail tr td:last-child{
                border-width:0px 0px 1px 0px;
            }.TabelaEmail tr:last-child td:last-child{
                border-width:0px 0px 0px 0px;
            }
            .TabelaEmail tr:first-child td{
                    background:-o-linear-gradient(bottom, #E95F28 5%, #E95F28 100%);    background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #E95F28), color-stop(1, #E95F28) );
                background:-moz-linear-gradient( center top, #E95F28 5%, #E95F28 100% );
                filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#E95F28", endColorstr="#E95F28");    background: -o-linear-gradient(top,#E95F28,E95F28);

                background-color:#ffffff;
                border:0px solid #000000;
                text-align:center;
                border-width:0px 0px 1px 1px;
                font-size:15px;
                font-family:Arial;
                font-weight:bold;
                color:#000000;
            }
            .TabelaEmail tr:first-child:hover td{
                background:-o-linear-gradient(bottom, #E95F28 5%, #bf5f00 100%);    background:-webkit-gradient( linear, left top, left bottom, color-stop(0.05, #E95F28), color-stop(1, #bf5f00) );
                background:-moz-linear-gradient( center top, #E95F28 5%, #bf5f00 100% );
                filter:progid:DXImageTransform.Microsoft.gradient(startColorstr="#E95F28", endColorstr="#bf5f00");    background: -o-linear-gradient(top,#E95F28,bf5f00);

                background-color:#ffffff;
            }
            .TabelaEmail tr:first-child td:first-child{
                border-width:0px 0px 1px 0px;
            }
            .TabelaEmail tr:first-child td:last-child{
                border-width:0px 0px 1px 1px;
            }
            </style>'.
            '<meta http-equiv="content-type" content="text/html; charset=UTF-8">'.
            '</head>'.
            '<body>'.
            '<center>'.
            '<div class="TabelaEmail" style="width: 600;">'.
            '<table style="height: 200;>'.
            '<tr>'.
            '<td valign="top" align="center">'.
            '<strong>'.
            '<font face="Arial" size="4"> '.$subject.' </font>'.
            '</strong>'.
            '</td>'.
            '</tr>'.
            '<tr>'.
            '<td>'.
            '<font face="Arial" size="2"> '.$content.' </font>'.
            '<center>'.$logoImage.'</center>'.
            '</td>'.
            '</tr>'.
            '</table>'.
            '</div>'.
            '</center>'.
            '</body>'.
            '</html>'
        ;
    }

}