<?php
namespace Zeedhi\PaymentPlatform;

class Address {

    /** @var string */
    private $street;
    /** @var string */
    private $number;
    /** @var string */
    private $complement;
    /** @var string */
    private $neighborhood;
    /** @var string */
    private $city;
    /** @var string */
    private $state;
    /** @var string */
    private $zipCode;
    /** @var string */
    private $country;
    /** @var string */
    private $metadata;
    
    /**
     * @param string $street
     * @param string $number
     * @param string $complement
     * @param string $neighborhood
     * @param string $city
     * @param string $state
     * @param string $zipCode
     * @param string $country
     */
    public function __construct($street, $number, $complement, $neighborhood, $city, $state, $zipCode, $country, $metadata) {
        $this->street = $street;
        $this->number = $number;
        $this->complement = $complement;
        $this->neighborhood = $neighborhood;
        $this->city = $city;
        $this->state = $state;
        $this->zipCode = $zipCode;
        $this->country = $country;
        $this->metadata = $metadata;
    }

    /**
     * @return string
     */
    public function getStreet(){
        return $this->street;
    }
    /**
     * @return string
     */
    public function getNumber(){
        return $this->number;
    }
    /**
     * @return string
     */
    public function getComplement(){
        return $this->complement;
    }
    /**
     * @return string
     */
    public function getNeighborhood(){
        return $this->neighborhood;
    }
    /**
     * @return string
     */
    public function getCity(){
        return $this->city;
    }
    /**
     * @return string
     */
    public function getState(){
        return $this->state;
    }
    /**
     * @return string
     */
    public function getZipCode(){
        return $this->zipCode;
    }
    /**
     * @return string
     */
    public function getCountry(){
        return $this->country;
    }
    /**
     * @return string
     */
    public function getMetadata(){
        return $this->metadata;
    }
}