<?php
namespace Zeedhi\PaymentPlatform\InstantBuy;

use Zeedhi\PaymentPlatform\CreditCard;
use Zeedhi\PaymentPlatform\Customer;

interface InstantBuyPlatform {

    /**
     * Register the given credit card in Payment Platform.
     * And return a token and a customer id for easy usage in next transactions.
     *
     * @param CreditCard $card The card to be registered.
     * @param Customer $customer The customer to be registered.
     *
     * @return array with InstantBuyKey and CustomerId.
     */
    public function createToken(CreditCard $card, Customer $customer);

    /**
     * Make a transaction with data detailed in InstantBuy object.
     *
     * @param InstantBuyTransaction $instantBuyTransaction The data about client token and transaction.
     *
     * @return String with TransactionKey.
     */
    public function instantBuyTransaction(InstantBuyTransaction $instantBuyTransaction);

    public function captureTransaction($url, $paymentId);
    
}