function ChangePasswordController(ScreenService, ProfileService, LoginRepository, ConsumerRepository){

    this.clearFields = function(widget){
        widget.setCurrentRow({});
    };

    this.changePassword = function(currentPassword, newPassword, check){
        if (this.validateFields(currentPassword, newPassword, check)){
            ScreenService.showMessage('Favor preencher todos os campos.');
        }
        else if (newPassword !== check){
            ScreenService.showMessage('As duas senhas não são iguais.');
        }
        else {
            ConsumerRepository.findOne().then(function (consumerData){
                ProfileService.changePassword(consumerData['CDCLIENTE'], consumerData['NMLOGINCONS'], currentPassword, newPassword, consumerData['CDFILIAL']).then(function (){
                    ScreenService.goBack();
                });
            });
        }
    };

    this.validateFields = function(currentPassword, newPassword, check){
        /* Checks if the fields are filled. Returns false if any field is left blank. */
        return (currentPassword == null || currentPassword == '' ||
               newPassword == null || newPassword == '' ||
               check == null || check == '');
    };

}

Configuration(function(ContextRegister){
    ContextRegister.register('ChangePasswordController', ChangePasswordController);
});