function SpeakToUsController(ScreenService, ConsumerRepository, ProfileService, LoginRepository, SpeakToUsService, Utilities){

    this.prepareForm = function(widget){
        ConsumerRepository.findOne().then(function (consumerData){
            ProfileService.getConsumerDetails(consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], consumerData['CDFILIAL']).then(function (consumerDetails){
                var formRow = {
                    'subect': null,
                    'email': consumerDetails[0]['DSEMAILCONS'],
                    'telefone': consumerDetails[0]['NRTELECONS'],
                    'body': null
                };
                widget.setCurrentRow(formRow);
            }); 
        });
    };

    this.submitForm = function(form){
        LoginRepository.findOne().then(function (consumerData){
            if (this.validateForm(form)) {
                if (form.subject == null) {
                    form.subject = "Sem Assunto";
                }
                if (form.email) form.email = form.email.toLowerCase();
                SpeakToUsService.submitForm(form.subject, form.email, form.telefone, form.body, consumerData['CDCLIENTE'], consumerData['CDCONSUMIDOR'], Utilities.appUrl, Utilities.logoEmpresa).then(function (){
                    ScreenService.showMessage('Sua mensagem foi enviada.');
                    ScreenService.openWindow('parentDashboard');
                });
            } else {
                ScreenService.showMessage('Favor inserir uma mensagem.');
            }
        }.bind(this));
    };

    this.validateForm = function(form) {
        var retorno = true;
        if (form.body) {
            if (form.body.length == 0) {
                retorno = false;
            }
        } else {
            retorno = false;
        }

        return retorno;
    };

};

Configuration(function(ContextRegister){
    ContextRegister.register('SpeakToUsController', SpeakToUsController);
});
